/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFlexClustersConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique 24-hexadecimal character string that identifies the project.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/flex_clusters#project_id DataMongodbatlasFlexClusters#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasFlexClustersResultsBackupSettings {
}
export declare function dataMongodbatlasFlexClustersResultsBackupSettingsToTerraform(struct?: DataMongodbatlasFlexClustersResultsBackupSettings): any;
export declare function dataMongodbatlasFlexClustersResultsBackupSettingsToHclTerraform(struct?: DataMongodbatlasFlexClustersResultsBackupSettings): any;
export declare class DataMongodbatlasFlexClustersResultsBackupSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasFlexClustersResultsBackupSettings | undefined;
    set internalValue(value: DataMongodbatlasFlexClustersResultsBackupSettings | undefined);
    get enabled(): cdktf.IResolvable;
}
export interface DataMongodbatlasFlexClustersResultsConnectionStrings {
}
export declare function dataMongodbatlasFlexClustersResultsConnectionStringsToTerraform(struct?: DataMongodbatlasFlexClustersResultsConnectionStrings): any;
export declare function dataMongodbatlasFlexClustersResultsConnectionStringsToHclTerraform(struct?: DataMongodbatlasFlexClustersResultsConnectionStrings): any;
export declare class DataMongodbatlasFlexClustersResultsConnectionStringsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasFlexClustersResultsConnectionStrings | undefined;
    set internalValue(value: DataMongodbatlasFlexClustersResultsConnectionStrings | undefined);
    get standard(): string;
    get standardSrv(): string;
}
export interface DataMongodbatlasFlexClustersResultsProviderSettings {
}
export declare function dataMongodbatlasFlexClustersResultsProviderSettingsToTerraform(struct?: DataMongodbatlasFlexClustersResultsProviderSettings): any;
export declare function dataMongodbatlasFlexClustersResultsProviderSettingsToHclTerraform(struct?: DataMongodbatlasFlexClustersResultsProviderSettings): any;
export declare class DataMongodbatlasFlexClustersResultsProviderSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasFlexClustersResultsProviderSettings | undefined;
    set internalValue(value: DataMongodbatlasFlexClustersResultsProviderSettings | undefined);
    get backingProviderName(): string;
    get diskSizeGb(): number;
    get providerName(): string;
    get regionName(): string;
}
export interface DataMongodbatlasFlexClustersResults {
}
export declare function dataMongodbatlasFlexClustersResultsToTerraform(struct?: DataMongodbatlasFlexClustersResults): any;
export declare function dataMongodbatlasFlexClustersResultsToHclTerraform(struct?: DataMongodbatlasFlexClustersResults): any;
export declare class DataMongodbatlasFlexClustersResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFlexClustersResults | undefined;
    set internalValue(value: DataMongodbatlasFlexClustersResults | undefined);
    private _backupSettings;
    get backupSettings(): DataMongodbatlasFlexClustersResultsBackupSettingsOutputReference;
    get clusterType(): string;
    private _connectionStrings;
    get connectionStrings(): DataMongodbatlasFlexClustersResultsConnectionStringsOutputReference;
    get createDate(): string;
    get id(): string;
    get mongoDbVersion(): string;
    get name(): string;
    get projectId(): string;
    private _providerSettings;
    get providerSettings(): DataMongodbatlasFlexClustersResultsProviderSettingsOutputReference;
    get stateName(): string;
    private _tags;
    get tags(): cdktf.StringMap;
    get terminationProtectionEnabled(): cdktf.IResolvable;
    get versionReleaseSystem(): string;
}
export declare class DataMongodbatlasFlexClustersResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFlexClustersResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/flex_clusters mongodbatlas_flex_clusters}
*/
export declare class DataMongodbatlasFlexClusters extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_flex_clusters";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasFlexClusters resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasFlexClusters to import
    * @param importFromId The id of the existing DataMongodbatlasFlexClusters that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/flex_clusters#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasFlexClusters to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/flex_clusters mongodbatlas_flex_clusters} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFlexClustersConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFlexClustersConfig);
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasFlexClustersResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
