/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasStreamConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/stream_connection#connection_name DataMongodbatlasStreamConnection#connection_name}
    */
    readonly connectionName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/stream_connection#instance_name DataMongodbatlasStreamConnection#instance_name}
    */
    readonly instanceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/stream_connection#project_id DataMongodbatlasStreamConnection#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasStreamConnectionAuthentication {
}
export declare function dataMongodbatlasStreamConnectionAuthenticationToTerraform(struct?: DataMongodbatlasStreamConnectionAuthentication): any;
export declare function dataMongodbatlasStreamConnectionAuthenticationToHclTerraform(struct?: DataMongodbatlasStreamConnectionAuthentication): any;
export declare class DataMongodbatlasStreamConnectionAuthenticationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionAuthentication | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionAuthentication | undefined);
    get mechanism(): string;
    get password(): string;
    get username(): string;
}
export interface DataMongodbatlasStreamConnectionAws {
}
export declare function dataMongodbatlasStreamConnectionAwsToTerraform(struct?: DataMongodbatlasStreamConnectionAws): any;
export declare function dataMongodbatlasStreamConnectionAwsToHclTerraform(struct?: DataMongodbatlasStreamConnectionAws): any;
export declare class DataMongodbatlasStreamConnectionAwsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionAws | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionAws | undefined);
    get roleArn(): string;
}
export interface DataMongodbatlasStreamConnectionDbRoleToExecute {
}
export declare function dataMongodbatlasStreamConnectionDbRoleToExecuteToTerraform(struct?: DataMongodbatlasStreamConnectionDbRoleToExecute): any;
export declare function dataMongodbatlasStreamConnectionDbRoleToExecuteToHclTerraform(struct?: DataMongodbatlasStreamConnectionDbRoleToExecute): any;
export declare class DataMongodbatlasStreamConnectionDbRoleToExecuteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionDbRoleToExecute | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionDbRoleToExecute | undefined);
    get role(): string;
    get type(): string;
}
export interface DataMongodbatlasStreamConnectionNetworkingAccess {
}
export declare function dataMongodbatlasStreamConnectionNetworkingAccessToTerraform(struct?: DataMongodbatlasStreamConnectionNetworkingAccess): any;
export declare function dataMongodbatlasStreamConnectionNetworkingAccessToHclTerraform(struct?: DataMongodbatlasStreamConnectionNetworkingAccess): any;
export declare class DataMongodbatlasStreamConnectionNetworkingAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionNetworkingAccess | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionNetworkingAccess | undefined);
    get connectionId(): string;
    get type(): string;
}
export interface DataMongodbatlasStreamConnectionNetworking {
}
export declare function dataMongodbatlasStreamConnectionNetworkingToTerraform(struct?: DataMongodbatlasStreamConnectionNetworking): any;
export declare function dataMongodbatlasStreamConnectionNetworkingToHclTerraform(struct?: DataMongodbatlasStreamConnectionNetworking): any;
export declare class DataMongodbatlasStreamConnectionNetworkingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionNetworking | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionNetworking | undefined);
    private _access;
    get access(): DataMongodbatlasStreamConnectionNetworkingAccessOutputReference;
}
export interface DataMongodbatlasStreamConnectionSecurity {
}
export declare function dataMongodbatlasStreamConnectionSecurityToTerraform(struct?: DataMongodbatlasStreamConnectionSecurity): any;
export declare function dataMongodbatlasStreamConnectionSecurityToHclTerraform(struct?: DataMongodbatlasStreamConnectionSecurity): any;
export declare class DataMongodbatlasStreamConnectionSecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionSecurity | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionSecurity | undefined);
    get brokerPublicCertificate(): string;
    get protocol(): string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/stream_connection mongodbatlas_stream_connection}
*/
export declare class DataMongodbatlasStreamConnection extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_stream_connection";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasStreamConnection resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasStreamConnection to import
    * @param importFromId The id of the existing DataMongodbatlasStreamConnection that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/stream_connection#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasStreamConnection to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.29.0/docs/data-sources/stream_connection mongodbatlas_stream_connection} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasStreamConnectionConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasStreamConnectionConfig);
    private _authentication;
    get authentication(): DataMongodbatlasStreamConnectionAuthenticationOutputReference;
    private _aws;
    get aws(): DataMongodbatlasStreamConnectionAwsOutputReference;
    get bootstrapServers(): string;
    get clusterName(): string;
    private _config;
    get config(): cdktf.StringMap;
    private _connectionName?;
    get connectionName(): string;
    set connectionName(value: string);
    get connectionNameInput(): string | undefined;
    private _dbRoleToExecute;
    get dbRoleToExecute(): DataMongodbatlasStreamConnectionDbRoleToExecuteOutputReference;
    get id(): string;
    private _instanceName?;
    get instanceName(): string;
    set instanceName(value: string);
    get instanceNameInput(): string | undefined;
    private _networking;
    get networking(): DataMongodbatlasStreamConnectionNetworkingOutputReference;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _security;
    get security(): DataMongodbatlasStreamConnectionSecurityOutputReference;
    get type(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
